package com.ruoyi.common.service;

import com.ruoyi.common.domain.Annex;
import com.ruoyi.common.bo.AnnexQueryBo;
import com.ruoyi.common.core.mybatisplus.core.IServicePlus;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.domain.dto.AnnexDTO;

import java.util.Collection;
import java.util.List;

/**
 * 附件Service接口
 *
 * @author ruoyi
 * @date 2025-02-14
 */
public interface IAnnexService extends IServicePlus<Annex> {
    /**
     * 查询单个
     * @return
     */
    Annex queryById(String id);

    /**
     * 查询列表
     */
    TableDataInfo<Annex> queryPageList(AnnexQueryBo bo);

    /**
     * 查询列表
     */
    List<Annex> queryList(AnnexQueryBo bo);

    /**
     * 根据新增业务对象插入附件
     * @param bo 附件新增业务对象
     * @return
     */
    Boolean insert(Annex bo);

    /**
     * 根据编辑业务对象修改附件
     * @param bo 附件编辑业务对象
     * @return
     */
    Boolean update(Annex bo);

    /**
     * 校验并删除数据
     * @param ids 主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return
     */
    Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid);


	/**
	 * 删除指定类型的附件
	 * @param  types 类型集合
	 * @return
	 */
	void deleteByTypes(List<String> types);

	/**
	 * 附件批量添加
	 * @param  annexList 附件集合
	 * @return
	 */
	void insertBatch(List<AnnexDTO> annexList);


	/**
	 * 根据表自增ID来删除指定附件数据，并删除对应的资源
	 */
	Boolean deleteByIds(Long id);
}
